diff --git a/meson.build b/meson.build
index d7c5193d4ce..4972c7b26d4 100644
--- a/meson.build
+++ b/meson.build
@@ -1902,64 +1902,64 @@ testsrc = '''
 extern void emit_log(int ignore, const char *fmt,...) __attribute__((format(@0@, 2,3)));
 static void call_log(void)
 {
-    emit_log(0, "error: %s: %m", "foo");
+		emit_log(0, "error: %s: %m", "foo");
 }
 '''
 attrib_error_args = cc.get_supported_arguments('-Werror=format', '-Werror=ignored-attributes')
 foreach a : printf_attributes
-  if cc.compiles(testsrc.format(a),
-      args: test_c_args + attrib_error_args, name: 'format ' + a)
-    cdata.set('PG_C_PRINTF_ATTRIBUTE', a)
-    break
-  endif
+	if cc.compiles(testsrc.format(a),
+			args: test_c_args + attrib_error_args, name: 'format ' + a)
+		cdata.set('PG_C_PRINTF_ATTRIBUTE', a)
+		break
+	endif
 endforeach
 
 # We need to repeat the test for C++ because gcc and clang prefer different
 # format archetypes.
 if llvm.found()
-  attrib_error_args = cpp.get_supported_arguments('-Werror=format', '-Werror=ignored-attributes')
-  foreach a : printf_attributes
-    if cpp.compiles(testsrc.format(a),
-        args: attrib_error_args, name: 'cppformat ' + a)
-      cdata.set('PG_CXX_PRINTF_ATTRIBUTE', a)
-      break
-    endif
-  endforeach
+	attrib_error_args = cpp.get_supported_arguments('-Werror=format', '-Werror=ignored-attributes')
+	foreach a : printf_attributes
+		if cpp.compiles(testsrc.format(a),
+				args: attrib_error_args, name: 'cppformat ' + a)
+			cdata.set('PG_CXX_PRINTF_ATTRIBUTE', a)
+			break
+		endif
+	endforeach
 endif
 
 
 if cc.has_function_attribute('visibility:default') and \
-    cc.has_function_attribute('visibility:hidden')
-  cdata.set('HAVE_VISIBILITY_ATTRIBUTE', 1)
+		cc.has_function_attribute('visibility:hidden')
+	cdata.set('HAVE_VISIBILITY_ATTRIBUTE', 1)
 
-  # Only newer versions of meson know not to apply gnu_symbol_visibility =
-  # inlineshidden to C code as well... And either way, we want to put these
-  # flags into exported files (pgxs, .pc files).
-  cflags_mod += '-fvisibility=hidden'
-  cxxflags_mod += ['-fvisibility=hidden', '-fvisibility-inlines-hidden']
-  ldflags_mod += '-fvisibility=hidden'
+	# Only newer versions of meson know not to apply gnu_symbol_visibility =
+	# inlineshidden to C code as well... And either way, we want to put these
+	# flags into exported files (pgxs, .pc files).
+	cflags_mod += '-fvisibility=hidden'
+	cxxflags_mod += ['-fvisibility=hidden', '-fvisibility-inlines-hidden']
+	ldflags_mod += '-fvisibility=hidden'
 endif
 
 
 # Check if various builtins exist. Some builtins are tested separately,
 # because we want to test something more complicated than the generic case.
 builtins = [
-  'bswap16',
-  'bswap32',
-  'bswap64',
-  'clz',
-  'ctz',
-  'constant_p',
-  'frame_address',
-  'popcount',
-  'unreachable',
+	'bswap16',
+	'bswap32',
+	'bswap64',
+	'clz',
+	'ctz',
+	'constant_p',
+	'frame_address',
+	'popcount',
+	'unreachable',
 ]
 
 foreach builtin : builtins
-  fname = '__builtin_@0@'.format(builtin)
-  if cc.has_function(fname, args: test_c_args)
-    cdata.set('HAVE@0@'.format(fname.to_upper()), 1)
-  endif
+	fname = '__builtin_@0@'.format(builtin)
+	if cc.has_function(fname, args: test_c_args)
+		cdata.set('HAVE@0@'.format(fname.to_upper()), 1)
+	endif
 endforeach
 
 
@@ -1969,12 +1969,12 @@ endforeach
 # We check usage with __typeof__, though it's unlikely any compiler would
 # have the former and not the latter.
 if cc.compiles('''
-    static int x;
-    static int y[__builtin_types_compatible_p(__typeof__(x), int)];
-    ''',
-    name: '__builtin_types_compatible_p',
-    args: test_c_args)
-  cdata.set('HAVE__BUILTIN_TYPES_COMPATIBLE_P', 1)
+		static int x;
+		static int y[__builtin_types_compatible_p(__typeof__(x), int)];
+		''',
+		name: '__builtin_types_compatible_p',
+		args: test_c_args)
+	cdata.set('HAVE__BUILTIN_TYPES_COMPATIBLE_P', 1)
 endif
 
 
@@ -1987,65 +1987,65 @@ endif
 # compile, and store the results in global variables so the compiler doesn't
 # optimize away the call.
 if cc.links('''
-    #include <stdint.h>
-    int64_t a = 1;
-    int64_t b = 1;
-    int64_t result;
+		#include <stdint.h>
+		int64_t a = 1;
+		int64_t b = 1;
+		int64_t result;
 
-    int main(void)
-    {
-        return __builtin_mul_overflow(a, b, &result);
-    }''',
-    name: '__builtin_mul_overflow',
-    args: test_c_args)
-  cdata.set('HAVE__BUILTIN_OP_OVERFLOW', 1)
+		int main(void)
+		{
+				return __builtin_mul_overflow(a, b, &result);
+		}''',
+		name: '__builtin_mul_overflow',
+		args: test_c_args)
+	cdata.set('HAVE__BUILTIN_OP_OVERFLOW', 1)
 endif
 
 # Check for __get_cpuid() and __cpuid().
 if cc.links('''
-    #include <cpuid.h>
-    int main(int arg, char **argv)
-    {
-        unsigned int exx[4] = {0, 0, 0, 0};
-        __get_cpuid(1, &exx[0], &exx[1], &exx[2], &exx[3]);
-    }
-    ''', name: '__get_cpuid',
-    args: test_c_args)
-  cdata.set('HAVE__GET_CPUID', 1)
+		#include <cpuid.h>
+		int main(int arg, char **argv)
+		{
+				unsigned int exx[4] = {0, 0, 0, 0};
+				__get_cpuid(1, &exx[0], &exx[1], &exx[2], &exx[3]);
+		}
+		''', name: '__get_cpuid',
+		args: test_c_args)
+	cdata.set('HAVE__GET_CPUID', 1)
 elif cc.links('''
-    #include <intrin.h>
-    int main(int arg, char **argv)
-    {
-        unsigned int exx[4] = {0, 0, 0, 0};
-        __cpuid(exx, 1);
-    }
-    ''', name: '__cpuid',
-    args: test_c_args)
-  cdata.set('HAVE__CPUID', 1)
+		#include <intrin.h>
+		int main(int arg, char **argv)
+		{
+				unsigned int exx[4] = {0, 0, 0, 0};
+				__cpuid(exx, 1);
+		}
+		''', name: '__cpuid',
+		args: test_c_args)
+	cdata.set('HAVE__CPUID', 1)
 endif
 
 
 # Check for __get_cpuid_count() and __cpuidex() in a similar fashion.
 if cc.links('''
-    #include <cpuid.h>
-    int main(int arg, char **argv)
-    {
-        unsigned int exx[4] = {0, 0, 0, 0};
-        __get_cpuid_count(7, 0, &exx[0], &exx[1], &exx[2], &exx[3]);
-    }
-    ''', name: '__get_cpuid_count',
-    args: test_c_args)
-  cdata.set('HAVE__GET_CPUID_COUNT', 1)
+		#include <cpuid.h>
+		int main(int arg, char **argv)
+		{
+				unsigned int exx[4] = {0, 0, 0, 0};
+				__get_cpuid_count(7, 0, &exx[0], &exx[1], &exx[2], &exx[3]);
+		}
+		''', name: '__get_cpuid_count',
+		args: test_c_args)
+	cdata.set('HAVE__GET_CPUID_COUNT', 1)
 elif cc.links('''
-    #include <intrin.h>
-    int main(int arg, char **argv)
-    {
-        unsigned int exx[4] = {0, 0, 0, 0};
-        __cpuidex(exx, 7, 0);
-    }
-    ''', name: '__cpuidex',
-    args: test_c_args)
-  cdata.set('HAVE__CPUIDEX', 1)
+		#include <intrin.h>
+		int main(int arg, char **argv)
+		{
+				unsigned int exx[4] = {0, 0, 0, 0};
+				__cpuidex(exx, 7, 0);
+		}
+		''', name: '__cpuidex',
+		args: test_c_args)
+	cdata.set('HAVE__CPUIDEX', 1)
 endif
 
 
@@ -2059,13 +2059,13 @@ endif
 # -fexcess-precision=standard, that way a potentially fixed compiler will work
 # automatically.
 if '-fexcess-precision=standard' not in cflags
-  if not cc.compiles('''
+	if not cc.compiles('''
 #if defined(__clang__) && defined(__i386__) && !defined(__SSE2_MATH__)
 choke me
 #endif''',
-      name: '', args: test_c_args)
-    error('Compiling PostgreSQL with clang, on 32bit x86, requires SSE2 support. Use -msse2 or use gcc.')
-  endif
+			name: '', args: test_c_args)
+		error('Compiling PostgreSQL with clang, on 32bit x86, requires SSE2 support. Use -msse2 or use gcc.')
+	endif
 endif
 
 
@@ -2075,48 +2075,48 @@ endif
 ###############################################################
 
 common_functional_flags = [
-  # Disable strict-aliasing rules; needed for gcc 3.3+
-  '-fno-strict-aliasing',
-  # Disable optimizations that assume no overflow; needed for gcc 4.3+
-  '-fwrapv',
-  '-fexcess-precision=standard',
+	# Disable strict-aliasing rules; needed for gcc 3.3+
+	'-fno-strict-aliasing',
+	# Disable optimizations that assume no overflow; needed for gcc 4.3+
+	'-fwrapv',
+	'-fexcess-precision=standard',
 ]
 
 cflags += cc.get_supported_arguments(common_functional_flags)
 if llvm.found()
-  cxxflags += cpp.get_supported_arguments(common_functional_flags)
+	cxxflags += cpp.get_supported_arguments(common_functional_flags)
 endif
 
 vectorize_cflags = cc.get_supported_arguments(['-ftree-vectorize'])
 unroll_loops_cflags = cc.get_supported_arguments(['-funroll-loops'])
 
 common_warning_flags = [
-  '-Wmissing-prototypes',
-  '-Wpointer-arith',
-  # Really don't want VLAs to be used in our dialect of C
-  '-Werror=vla',
-  # On macOS, complain about usage of symbols newer than the deployment target
-  '-Werror=unguarded-availability-new',
-  '-Wendif-labels',
-  '-Wmissing-format-attribute',
-  '-Wimplicit-fallthrough=3',
-  '-Wcast-function-type',
-  '-Wshadow=compatible-local',
-  # This was included in -Wall/-Wformat in older GCC versions
-  '-Wformat-security',
+	'-Wmissing-prototypes',
+	'-Wpointer-arith',
+	# Really don't want VLAs to be used in our dialect of C
+	'-Werror=vla',
+	# On macOS, complain about usage of symbols newer than the deployment target
+	'-Werror=unguarded-availability-new',
+	'-Wendif-labels',
+	'-Wmissing-format-attribute',
+	'-Wimplicit-fallthrough=3',
+	'-Wcast-function-type',
+	'-Wshadow=compatible-local',
+	# This was included in -Wall/-Wformat in older GCC versions
+	'-Wformat-security',
 ]
 
 cflags_warn += cc.get_supported_arguments(common_warning_flags)
 if llvm.found()
-  cxxflags_warn += cpp.get_supported_arguments(common_warning_flags)
+	cxxflags_warn += cpp.get_supported_arguments(common_warning_flags)
 endif
 
 # A few places with imported code get a pass on -Wdeclaration-after-statement, remember
 # the result for them
 cflags_no_decl_after_statement = []
 if cc.has_argument('-Wdeclaration-after-statement')
-  cflags_warn += '-Wdeclaration-after-statement'
-  cflags_no_decl_after_statement += '-Wno-declaration-after-statement'
+	cflags_warn += '-Wdeclaration-after-statement'
+	cflags_no_decl_after_statement += '-Wno-declaration-after-statement'
 endif
 
 # Some code is not clean for -Wmissing-variable-declarations, so we
@@ -2125,8 +2125,8 @@ endif
 # C++.
 cflags_no_missing_var_decls = []
 if cc.has_argument('-Wmissing-variable-declarations')
-  cflags_warn += '-Wmissing-variable-declarations'
-  cflags_no_missing_var_decls += '-Wno-missing-variable-declarations'
+	cflags_warn += '-Wmissing-variable-declarations'
+	cflags_no_missing_var_decls += '-Wno-missing-variable-declarations'
 endif
 
 
@@ -2136,69 +2136,69 @@ endif
 # add the negative form.
 
 negative_warning_flags = [
-  # Suppress clang's unhelpful unused-command-line-argument warnings.
-  'unused-command-line-argument',
+	# Suppress clang's unhelpful unused-command-line-argument warnings.
+	'unused-command-line-argument',
 
-  # Remove clang 12+'s compound-token-split-by-macro, as this causes a lot
-  # of warnings when building plperl because of usages in the Perl headers.
-  'compound-token-split-by-macro',
+	# Remove clang 12+'s compound-token-split-by-macro, as this causes a lot
+	# of warnings when building plperl because of usages in the Perl headers.
+	'compound-token-split-by-macro',
 
-  # Similarly disable useless truncation warnings from gcc 8+
-  'format-truncation',
-  'stringop-truncation',
+	# Similarly disable useless truncation warnings from gcc 8+
+	'format-truncation',
+	'stringop-truncation',
 
-  # Suppress clang 16's strict warnings about function casts
-  'cast-function-type-strict',
+	# Suppress clang 16's strict warnings about function casts
+	'cast-function-type-strict',
 
-  # To make warning_level=2 / -Wextra work, we'd need at least the following
-  # 'clobbered',
-  # 'missing-field-initializers',
-  # 'sign-compare',
-  # 'unused-parameter',
+	# To make warning_level=2 / -Wextra work, we'd need at least the following
+	# 'clobbered',
+	# 'missing-field-initializers',
+	# 'sign-compare',
+	# 'unused-parameter',
 ]
 
 foreach w : negative_warning_flags
-  if cc.has_argument('-W' + w)
-    cflags_warn += '-Wno-' + w
-  endif
-  if llvm.found() and cpp.has_argument('-W' + w)
-    cxxflags_warn += '-Wno-' + w
-  endif
+	if cc.has_argument('-W' + w)
+		cflags_warn += '-Wno-' + w
+	endif
+	if llvm.found() and cpp.has_argument('-W' + w)
+		cxxflags_warn += '-Wno-' + w
+	endif
 endforeach
 
 
 if cc.get_id() == 'msvc'
-  cflags_warn += [
-    # Warnings to disable:
-    # from /W1:
-    '/wd4090', # different 'modifier' qualifiers
-    # from /W2:
-    '/wd4244', # conversion from 'type1' to 'type2', possible loss of data
-    # from /W3:
-    '/wd4018', # signed/unsigned mismatch
-    '/wd4101', # unreferenced local variable [like -Wunused-variable, but there is no "unused" attribute, so too noisy]
-    '/wd4267', # conversion from 'size_t' to 'type', possible loss of data
-
-    # Additional warnings to enable:
-    '/w24062', # enumerator 'identifier' in switch of enum 'enumeration' is not handled [like -Wswitch]
-    '/w24102', # unreferenced label [like -Wunused-label]
-    '/w24777', # 'function' : format string 'string' requires an argument of type 'type1', but variadic argument number has type 'type2' [like -Wformat]
-  ]
-
-  cppflags += [
-    '/DWIN32',
-    '/DWINDOWS',
-    '/D__WINDOWS__',
-    '/D__WIN32__',
-    '/D_CRT_SECURE_NO_DEPRECATE',
-    '/D_CRT_NONSTDC_NO_DEPRECATE',
-  ]
-
-  # We never need export libraries. As link.exe reports their creation, they
-  # are unnecessarily noisy. Similarly, we don't need import library for
-  # modules, we only import them dynamically, and they're also noisy.
-  ldflags += '/NOEXP'
-  ldflags_mod += '/NOIMPLIB'
+	cflags_warn += [
+		# Warnings to disable:
+		# from /W1:
+		'/wd4090', # different 'modifier' qualifiers
+		# from /W2:
+		'/wd4244', # conversion from 'type1' to 'type2', possible loss of data
+		# from /W3:
+		'/wd4018', # signed/unsigned mismatch
+		'/wd4101', # unreferenced local variable [like -Wunused-variable, but there is no "unused" attribute, so too noisy]
+		'/wd4267', # conversion from 'size_t' to 'type', possible loss of data
+
+		# Additional warnings to enable:
+		'/w24062', # enumerator 'identifier' in switch of enum 'enumeration' is not handled [like -Wswitch]
+		'/w24102', # unreferenced label [like -Wunused-label]
+		'/w24777', # 'function' : format string 'string' requires an argument of type 'type1', but variadic argument number has type 'type2' [like -Wformat]
+	]
+
+	cppflags += [
+		'/DWIN32',
+		'/DWINDOWS',
+		'/D__WINDOWS__',
+		'/D__WIN32__',
+		'/D_CRT_SECURE_NO_DEPRECATE',
+		'/D_CRT_NONSTDC_NO_DEPRECATE',
+	]
+
+	# We never need export libraries. As link.exe reports their creation, they
+	# are unnecessarily noisy. Similarly, we don't need import library for
+	# modules, we only import them dynamically, and they're also noisy.
+	ldflags += '/NOEXP'
+	ldflags_mod += '/NOIMPLIB'
 endif
 
 
@@ -2212,25 +2212,25 @@ endif
 common_builtin_flags = ['-Wall']
 
 if get_option('debug')
-  common_builtin_flags += ['-g']
+	common_builtin_flags += ['-g']
 endif
 
 optimization = get_option('optimization')
 if optimization == '0'
-  common_builtin_flags += ['-O0']
+	common_builtin_flags += ['-O0']
 elif optimization == '1'
-  common_builtin_flags += ['-O1']
+	common_builtin_flags += ['-O1']
 elif optimization == '2'
-  common_builtin_flags += ['-O2']
+	common_builtin_flags += ['-O2']
 elif optimization == '3'
-  common_builtin_flags += ['-O3']
+	common_builtin_flags += ['-O3']
 elif optimization == 's'
-  common_builtin_flags += ['-Os']
+	common_builtin_flags += ['-Os']
 endif
 
 cflags_builtin = cc.get_supported_arguments(common_builtin_flags)
 if llvm.found()
-  cxxflags_builtin = cpp.get_supported_arguments(common_builtin_flags)
+	cxxflags_builtin = cpp.get_supported_arguments(common_builtin_flags)
 endif
 
 
@@ -2240,60 +2240,60 @@ endif
 ###############################################################
 
 atomic_checks = [
-  {'name': 'HAVE_GCC__SYNC_CHAR_TAS',
-   'desc': '__sync_lock_test_and_set(char)',
-   'test': '''
+	{'name': 'HAVE_GCC__SYNC_CHAR_TAS',
+	 'desc': '__sync_lock_test_and_set(char)',
+	 'test': '''
 char lock = 0;
 __sync_lock_test_and_set(&lock, 1);
 __sync_lock_release(&lock);'''},
 
-  {'name': 'HAVE_GCC__SYNC_INT32_TAS',
-   'desc': '__sync_lock_test_and_set(int32)',
-   'test': '''
+	{'name': 'HAVE_GCC__SYNC_INT32_TAS',
+	 'desc': '__sync_lock_test_and_set(int32)',
+	 'test': '''
 int lock = 0;
 __sync_lock_test_and_set(&lock, 1);
 __sync_lock_release(&lock);'''},
 
-  {'name': 'HAVE_GCC__SYNC_INT32_CAS',
-   'desc': '__sync_val_compare_and_swap(int32)',
-   'test': '''
+	{'name': 'HAVE_GCC__SYNC_INT32_CAS',
+	 'desc': '__sync_val_compare_and_swap(int32)',
+	 'test': '''
 int val = 0;
 __sync_val_compare_and_swap(&val, 0, 37);'''},
 
-  {'name': 'HAVE_GCC__SYNC_INT64_CAS',
-   'desc': '__sync_val_compare_and_swap(int64)',
-   'test': '''
+	{'name': 'HAVE_GCC__SYNC_INT64_CAS',
+	 'desc': '__sync_val_compare_and_swap(int64)',
+	 'test': '''
 int64_t val = 0;
 __sync_val_compare_and_swap(&val, 0, 37);'''},
 
-  {'name': 'HAVE_GCC__ATOMIC_INT32_CAS',
-   'desc': ' __atomic_compare_exchange_n(int32)',
-   'test': '''
+	{'name': 'HAVE_GCC__ATOMIC_INT32_CAS',
+	 'desc': ' __atomic_compare_exchange_n(int32)',
+	 'test': '''
 int val = 0;
 int expect = 0;
 __atomic_compare_exchange_n(&val, &expect, 37, 0, __ATOMIC_SEQ_CST, __ATOMIC_RELAXED);'''},
 
-  {'name': 'HAVE_GCC__ATOMIC_INT64_CAS',
-   'desc': ' __atomic_compare_exchange_n(int64)',
-   'test': '''
+	{'name': 'HAVE_GCC__ATOMIC_INT64_CAS',
+	 'desc': ' __atomic_compare_exchange_n(int64)',
+	 'test': '''
 int64_t val = 0;
 int64_t expect = 0;
 __atomic_compare_exchange_n(&val, &expect, 37, 0, __ATOMIC_SEQ_CST, __ATOMIC_RELAXED);'''},
 ]
 
 foreach check : atomic_checks
-  test = '''
+	test = '''
 #include <stdint.h>
 int main(void)
 {
 @0@
 }'''.format(check['test'])
 
-  cdata.set(check['name'],
-    cc.links(test,
-      name: check['desc'],
-      args: test_c_args) ? 1 : false
-  )
+	cdata.set(check['name'],
+		cc.links(test,
+			name: check['desc'],
+			args: test_c_args) ? 1 : false
+	)
 endforeach
 
 
@@ -2303,7 +2303,7 @@ endforeach
 
 if host_cpu == 'x86' or host_cpu == 'x86_64'
 
-  prog = '''
+	prog = '''
 #include <immintrin.h>
 
 #if defined(__has_attribute) && __has_attribute (target)
@@ -2311,13 +2311,13 @@ __attribute__((target("xsave")))
 #endif
 int main(void)
 {
-    return _xgetbv(0) & 0xe0;
+		return _xgetbv(0) & 0xe0;
 }
 '''
 
-  if cc.links(prog, name: 'XSAVE intrinsics', args: test_c_args)
-    cdata.set('HAVE_XSAVE_INTRINSICS', 1)
-  endif
+	if cc.links(prog, name: 'XSAVE intrinsics', args: test_c_args)
+		cdata.set('HAVE_XSAVE_INTRINSICS', 1)
+	endif
 
 endif
 
@@ -2328,7 +2328,7 @@ endif
 
 if host_cpu == 'x86_64'
 
-  prog = '''
+	prog = '''
 #include <immintrin.h>
 #include <stdint.h>
 char buf[sizeof(__m512i)];
@@ -2338,20 +2338,20 @@ __attribute__((target("avx512vpopcntdq,avx512bw")))
 #endif
 int main(void)
 {
-    int64_t popcnt = 0;
-    __m512i accum = _mm512_setzero_si512();
-    __m512i val = _mm512_maskz_loadu_epi8((__mmask64) 0xf0f0f0f0f0f0f0f0, (const __m512i *) buf);
-    __m512i cnt = _mm512_popcnt_epi64(val);
-    accum = _mm512_add_epi64(accum, cnt);
-    popcnt = _mm512_reduce_add_epi64(accum);
-    /* return computed value, to prevent the above being optimized away */
-    return popcnt == 0;
+		int64_t popcnt = 0;
+		__m512i accum = _mm512_setzero_si512();
+		__m512i val = _mm512_maskz_loadu_epi8((__mmask64) 0xf0f0f0f0f0f0f0f0, (const __m512i *) buf);
+		__m512i cnt = _mm512_popcnt_epi64(val);
+		accum = _mm512_add_epi64(accum, cnt);
+		popcnt = _mm512_reduce_add_epi64(accum);
+		/* return computed value, to prevent the above being optimized away */
+		return popcnt == 0;
 }
 '''
 
-  if cc.links(prog, name: 'AVX-512 popcount', args: test_c_args)
-    cdata.set('USE_AVX512_POPCNT_WITH_RUNTIME_CHECK', 1)
-  endif
+	if cc.links(prog, name: 'AVX-512 popcount', args: test_c_args)
+		cdata.set('USE_AVX512_POPCNT_WITH_RUNTIME_CHECK', 1)
+	endif
 
 endif
 
@@ -2362,7 +2362,7 @@ endif
 
 if host_cpu == 'aarch64'
 
-  prog = '''
+	prog = '''
 #include <arm_sve.h>
 
 char buf[128];
@@ -2397,9 +2397,9 @@ int main(void)
 }
 '''
 
-  if cc.links(prog, name: 'SVE popcount', args: test_c_args)
-    cdata.set('USE_SVE_POPCNT_WITH_RUNTIME_CHECK', 1)
-  endif
+	if cc.links(prog, name: 'SVE popcount', args: test_c_args)
+		cdata.set('USE_SVE_POPCNT_WITH_RUNTIME_CHECK', 1)
+	endif
 
 endif
 
@@ -2433,13 +2433,13 @@ have_optimized_crc = false
 cflags_crc = []
 if host_cpu == 'x86' or host_cpu == 'x86_64'
 
-  if cc.get_id() == 'msvc'
-    cdata.set('USE_SSE42_CRC32C', false)
-    cdata.set('USE_SSE42_CRC32C_WITH_RUNTIME_CHECK', 1)
-    have_optimized_crc = true
-  else
+	if cc.get_id() == 'msvc'
+		cdata.set('USE_SSE42_CRC32C', false)
+		cdata.set('USE_SSE42_CRC32C_WITH_RUNTIME_CHECK', 1)
+		have_optimized_crc = true
+	else
 
-    prog = '''
+		prog = '''
 #include <nmmintrin.h>
 unsigned int crc;
 
@@ -2448,32 +2448,32 @@ __attribute__((target("sse4.2")))
 #endif
 int main(void)
 {
-    crc = _mm_crc32_u8(crc, 0);
-    crc = _mm_crc32_u32(crc, 0);
-    /* return computed value, to prevent the above being optimized away */
-    return crc == 0;
+		crc = _mm_crc32_u8(crc, 0);
+		crc = _mm_crc32_u32(crc, 0);
+		/* return computed value, to prevent the above being optimized away */
+		return crc == 0;
 }
 '''
 
-    if not cc.links(prog, name: 'SSE 4.2 CRC32C',
-          args: test_c_args)
-      # Do not use Intel SSE 4.2
-    elif (cc.get_define('__SSE4_2__') != '')
-      # Use Intel SSE 4.2 unconditionally.
-      cdata.set('USE_SSE42_CRC32C', 1)
-      have_optimized_crc = true
-    else
-      # Use Intel SSE 4.2, with runtime check. The CPUID instruction is needed for
-      # the runtime check.
-      cdata.set('USE_SSE42_CRC32C', false)
-      cdata.set('USE_SSE42_CRC32C_WITH_RUNTIME_CHECK', 1)
-      have_optimized_crc = true
-    endif
-
-    # Check if the compiler supports AVX-512 carryless multiplication
-    # and three-way exclusive-or instructions used for computing CRC.
-    # AVX-512F is assumed to be supported if the above are.
-    prog = '''
+		if not cc.links(prog, name: 'SSE 4.2 CRC32C',
+					args: test_c_args)
+			# Do not use Intel SSE 4.2
+		elif (cc.get_define('__SSE4_2__') != '')
+			# Use Intel SSE 4.2 unconditionally.
+			cdata.set('USE_SSE42_CRC32C', 1)
+			have_optimized_crc = true
+		else
+			# Use Intel SSE 4.2, with runtime check. The CPUID instruction is needed for
+			# the runtime check.
+			cdata.set('USE_SSE42_CRC32C', false)
+			cdata.set('USE_SSE42_CRC32C_WITH_RUNTIME_CHECK', 1)
+			have_optimized_crc = true
+		endif
+
+		# Check if the compiler supports AVX-512 carryless multiplication
+		# and three-way exclusive-or instructions used for computing CRC.
+		# AVX-512F is assumed to be supported if the above are.
+		prog = '''
 #include <immintrin.h>
 __m512i x;
 __m512i y;
@@ -2483,99 +2483,137 @@ __attribute__((target("vpclmulqdq,avx512vl")))
 #endif
 int main(void)
 {
-     __m128i z;
-
-    x = _mm512_xor_si512(_mm512_zextsi128_si512(_mm_cvtsi32_si128(0)), x);
-    y = _mm512_clmulepi64_epi128(x, y, 0);
-    z = _mm_ternarylogic_epi64(
-            _mm512_castsi512_si128(y),
-            _mm512_extracti32x4_epi32(y, 1),
-            _mm512_extracti32x4_epi32(y, 2),
-            0x96);
-    /* return computed value, to prevent the above being optimized away */
-    return _mm_crc32_u64(0, _mm_extract_epi64(z, 0));
+		 __m128i z;
+
+		x = _mm512_xor_si512(_mm512_zextsi128_si512(_mm_cvtsi32_si128(0)), x);
+		y = _mm512_clmulepi64_epi128(x, y, 0);
+		z = _mm_ternarylogic_epi64(
+						_mm512_castsi512_si128(y),
+						_mm512_extracti32x4_epi32(y, 1),
+						_mm512_extracti32x4_epi32(y, 2),
+						0x96);
+		/* return computed value, to prevent the above being optimized away */
+		return _mm_crc32_u64(0, _mm_extract_epi64(z, 0));
 }
 '''
 
-    if cc.links(prog,
-        name: 'AVX-512 CRC32C',
-        args: test_c_args)
-      cdata.set('USE_AVX512_CRC32C_WITH_RUNTIME_CHECK', 1)
-    endif
+		if cc.links(prog,
+				name: 'AVX-512 CRC32C',
+				args: test_c_args)
+			cdata.set('USE_AVX512_CRC32C_WITH_RUNTIME_CHECK', 1)
+		endif
 
-  endif
+	endif
 
 elif host_cpu == 'arm' or host_cpu == 'aarch64'
 
-  prog = '''
+	prog = '''
 #include <arm_acle.h>
 unsigned int crc;
 
 int main(void)
 {
-    crc = __crc32cb(crc, 0);
-    crc = __crc32ch(crc, 0);
-    crc = __crc32cw(crc, 0);
-    crc = __crc32cd(crc, 0);
+		crc = __crc32cb(crc, 0);
+		crc = __crc32ch(crc, 0);
+		crc = __crc32cw(crc, 0);
+		crc = __crc32cd(crc, 0);
 
-    /* return computed value, to prevent the above being optimized away */
-    return crc == 0;
+		/* return computed value, to prevent the above being optimized away */
+		return crc == 0;
 }
 '''
 
-  if cc.links(prog, name: '__crc32cb, __crc32ch, __crc32cw, and __crc32cd without -march=armv8-a+crc',
-      args: test_c_args)
-    # Use ARM CRC Extension unconditionally
-    cdata.set('USE_ARMV8_CRC32C', 1)
-    have_optimized_crc = true
-  elif cc.links(prog, name: '__crc32cb, __crc32ch, __crc32cw, and __crc32cd with -march=armv8-a+crc+simd',
-      args: test_c_args + ['-march=armv8-a+crc+simd'])
-    # Use ARM CRC Extension, with runtime check
-    cflags_crc += '-march=armv8-a+crc+simd'
-    cdata.set('USE_ARMV8_CRC32C', false)
-    cdata.set('USE_ARMV8_CRC32C_WITH_RUNTIME_CHECK', 1)
-    have_optimized_crc = true
-  elif cc.links(prog, name: '__crc32cb, __crc32ch, __crc32cw, and __crc32cd with -march=armv8-a+crc',
-      args: test_c_args + ['-march=armv8-a+crc'])
-    # Use ARM CRC Extension, with runtime check
-    cflags_crc += '-march=armv8-a+crc'
-    cdata.set('USE_ARMV8_CRC32C', false)
-    cdata.set('USE_ARMV8_CRC32C_WITH_RUNTIME_CHECK', 1)
-    have_optimized_crc = true
-  endif
+	if cc.links(prog, name: '__crc32cb, __crc32ch, __crc32cw, and __crc32cd without -march=armv8-a+crc',
+			args: test_c_args)
+		# Use ARM CRC Extension unconditionally
+		cdata.set('USE_ARMV8_CRC32C', 1)
+		have_optimized_crc = true
+	elif cc.links(prog, name: '__crc32cb, __crc32ch, __crc32cw, and __crc32cd with -march=armv8-a+crc+simd',
+			args: test_c_args + ['-march=armv8-a+crc+simd'])
+		# Use ARM CRC Extension, with runtime check
+		cflags_crc += '-march=armv8-a+crc+simd'
+		cdata.set('USE_ARMV8_CRC32C', false)
+		cdata.set('USE_ARMV8_CRC32C_WITH_RUNTIME_CHECK', 1)
+		have_optimized_crc = true
+	elif cc.links(prog, name: '__crc32cb, __crc32ch, __crc32cw, and __crc32cd with -march=armv8-a+crc',
+			args: test_c_args + ['-march=armv8-a+crc'])
+		# Use ARM CRC Extension, with runtime check
+		cflags_crc += '-march=armv8-a+crc'
+		cdata.set('USE_ARMV8_CRC32C', false)
+		cdata.set('USE_ARMV8_CRC32C_WITH_RUNTIME_CHECK', 1)
+		have_optimized_crc = true
+	endif
 
 elif host_cpu == 'loongarch64'
 
-  prog = '''
+	prog = '''
 unsigned int crc;
 
 int main(void)
 {
-    crc = __builtin_loongarch_crcc_w_b_w(0, crc);
-    crc = __builtin_loongarch_crcc_w_h_w(0, crc);
-    crc = __builtin_loongarch_crcc_w_w_w(0, crc);
-    crc = __builtin_loongarch_crcc_w_d_w(0, crc);
+		crc = __builtin_loongarch_crcc_w_b_w(0, crc);
+		crc = __builtin_loongarch_crcc_w_h_w(0, crc);
+		crc = __builtin_loongarch_crcc_w_w_w(0, crc);
+		crc = __builtin_loongarch_crcc_w_d_w(0, crc);
 
-    /* return computed value, to prevent the above being optimized away */
-    return crc == 0;
+		/* return computed value, to prevent the above being optimized away */
+		return crc == 0;
 }
 '''
 
-  if cc.links(prog, name: '__builtin_loongarch_crcc_w_b_w, __builtin_loongarch_crcc_w_h_w, __builtin_loongarch_crcc_w_w_w, and __builtin_loongarch_crcc_w_d_w',
-      args: test_c_args)
-    # Use LoongArch CRC instruction unconditionally
-    cdata.set('USE_LOONGARCH_CRC32C', 1)
-    have_optimized_crc = true
-  endif
+	if cc.links(prog, name: '__builtin_loongarch_crcc_w_b_w, __builtin_loongarch_crcc_w_h_w, __builtin_loongarch_crcc_w_w_w, and __builtin_loongarch_crcc_w_d_w',
+			args: test_c_args)
+		# Use LoongArch CRC instruction unconditionally
+		cdata.set('USE_LOONGARCH_CRC32C', 1)
+		have_optimized_crc = true
+	endif
 
 endif
 
 if not have_optimized_crc
-  # fall back to slicing-by-8 algorithm, which doesn't require any special CPU
-  # support.
-  cdata.set('USE_SLICING_BY_8_CRC32C', 1)
+	# fall back to slicing-by-8 algorithm, which doesn't require any special CPU
+	# support.
+	cdata.set('USE_SLICING_BY_8_CRC32C', 1)
 endif
 
+###############################################################
+# Check for the availability of ARM SVE2 CRC32C intrinsics.
+###############################################################
+
+if host_cpu == 'aarch64'
+
+	prog = '''
+#include <arm_sve.h>
+#include <stdint.h>
+
+#if defined(__has_attribute) && __has_attribute(target)
+__attribute__((target("arch=armv9-a+sve2-aes")))
+#endif
+static int crc32c_sve2_test(void)
+{
+	svbool_t pg = svptrue_b64();
+	const uint64_t data[2] = { 0x1234567890abcdef, 0xfedcba0987654321 };
+	svuint64_t x1 = svld1_u64(pg, data);
+	svuint64_t x2 = svld1_u64(pg, data + 1);
+
+	// test key CRC folding ops
+	svuint64_t m1 = svpmullb_pair_u64(x1, x2);
+	svuint64_t m2 = svpmullt_pair_u64(x1, x2);
+	svuint64_t res = sveor3_u64(m1, m2, x2);
+	return (int)svaddv_u64(pg, res) & 1;
+}
+
+int main(void)
+{
+	return crc32c_sve2_test();
+}
+'''
+
+	if cc.links(prog, name: 'SVE2 CRC32C', args: test_c_args)
+		cdata.set('USE_SVE2_CRC32C_WITH_RUNTIME_CHECK', 1)
+	endif
+
+endif
 
 
 ###############################################################
@@ -2584,37 +2622,37 @@ endif
 
 if host_cpu == 'x86_64'
 
-  if cc.compiles('''
-      void main(void)
-      {
-          long long x = 1; long long r;
-          __asm__ __volatile__ (" popcntq %1,%0\n" : "=q"(r) : "rm"(x));
-      }''',
-      name: '@0@: popcntq instruction'.format(host_cpu),
-      args: test_c_args)
-    cdata.set('HAVE_X86_64_POPCNTQ', 1)
-  endif
+	if cc.compiles('''
+			void main(void)
+			{
+					long long x = 1; long long r;
+					__asm__ __volatile__ (" popcntq %1,%0\n" : "=q"(r) : "rm"(x));
+			}''',
+			name: '@0@: popcntq instruction'.format(host_cpu),
+			args: test_c_args)
+		cdata.set('HAVE_X86_64_POPCNTQ', 1)
+	endif
 
 elif host_cpu == 'ppc' or host_cpu == 'ppc64'
-  # Check if compiler accepts "i"(x) when __builtin_constant_p(x).
-  if cdata.has('HAVE__BUILTIN_CONSTANT_P')
-    if cc.compiles('''
-      static inline int
-      addi(int ra, int si)
-      {
-          int res = 0;
-          if (__builtin_constant_p(si))
-              __asm__ __volatile__(
-                  " addi %0,%1,%2\n" : "=r"(res) : "b"(ra), "i"(si));
-          return res;
-      }
-      int test_adds(int x) { return addi(3, x) + addi(x, 5); }
-      ''',
-      name: '@0@: "i"(x) when __builtin_constant_p(x)'.format(host_cpu),
-      args: test_c_args)
-      cdata.set('HAVE_I_CONSTRAINT__BUILTIN_CONSTANT_P', 1)
-    endif
-  endif
+	# Check if compiler accepts "i"(x) when __builtin_constant_p(x).
+	if cdata.has('HAVE__BUILTIN_CONSTANT_P')
+		if cc.compiles('''
+			static inline int
+			addi(int ra, int si)
+			{
+					int res = 0;
+					if (__builtin_constant_p(si))
+							__asm__ __volatile__(
+									" addi %0,%1,%2\n" : "=r"(res) : "b"(ra), "i"(si));
+					return res;
+			}
+			int test_adds(int x) { return addi(3, x) + addi(x, 5); }
+			''',
+			name: '@0@: "i"(x) when __builtin_constant_p(x)'.format(host_cpu),
+			args: test_c_args)
+			cdata.set('HAVE_I_CONSTRAINT__BUILTIN_CONSTANT_P', 1)
+		endif
+	endif
 endif
 
 
